/*
 * Licensed to Elastic Search and Shay Banon under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. Elastic Search licenses this
 * file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.elasticsearch.index.engine.robin;

import org.elasticsearch.index.analysis.AnalysisService;
import org.elasticsearch.index.engine.AbstractSimpleEngineTests;
import org.elasticsearch.index.engine.Engine;
import org.elasticsearch.index.similarity.SimilarityService;
import org.elasticsearch.index.store.Store;

import static org.elasticsearch.util.settings.ImmutableSettings.Builder.*;

/**
 * @author kimchy
 */
public class SimpleRobinEngineTests extends AbstractSimpleEngineTests {

    protected Engine createEngine(Store store) {
        return new RobinEngine(shardId, EMPTY_SETTINGS, store, createSnapshotDeletionPolicy(), createTranslog(), createMergePolicy(), createMergeScheduler(),
                new AnalysisService(shardId.index()), new SimilarityService(shardId.index()));
    }
}
